Compact a response
Compact a conversation. Returns a compacted response object.
Learn when and how to compact long-running conversations in the conversation state guide. For ZDR-compatible compaction details, see Compaction (advanced).
ParametersExpand Collapse
params BetaResponseCompactParams
Model param.Field[BetaResponseCompactParamsModel]Body param: Model ID used to generate the response, like gpt-5 or o3. OpenAI offers a wide range of models with different capabilities, performance characteristics, and price points. Refer to the model guide to browse and compare available models.
Body param: Model ID used to generate the response, like gpt-5 or o3. OpenAI offers a wide range of models with different capabilities, performance characteristics, and price points. Refer to the model guide to browse and compare available models.
type BetaResponseCompactParamsModel stringModel ID used to generate the response, like gpt-5 or o3. OpenAI offers a wide range of models with different capabilities, performance characteristics, and price points. Refer to the model guide to browse and compare available models.
Model ID used to generate the response, like gpt-5 or o3. OpenAI offers a wide range of models with different capabilities, performance characteristics, and price points. Refer to the model guide to browse and compare available models.
Body param: Text, image, or file inputs to the model, used to generate a response
Body param: Text, image, or file inputs to the model, used to generate a response
A list of one or many input items to the model, containing different content types.
A list of one or many input items to the model, containing different content types.
type BetaEasyInputMessage struct{…}A message input to the model with a role indicating instruction following
hierarchy. Instructions given with the developer or system role take
precedence over instructions given with the user role. Messages with the
assistant role are presumed to have been generated by the model in previous
interactions.
A message input to the model with a role indicating instruction following
hierarchy. Instructions given with the developer or system role take
precedence over instructions given with the user role. Messages with the
assistant role are presumed to have been generated by the model in previous
interactions.
Content BetaEasyInputMessageContentUnionText, image, or audio input to the model, used to generate a response.
Can also contain previous assistant responses.
Text, image, or audio input to the model, used to generate a response. Can also contain previous assistant responses.
A list of one or many input items to the model, containing different content
types.
A list of one or many input items to the model, containing different content types.
type BetaResponseInputImage struct{…}An image input to the model. Learn about image inputs.
An image input to the model. Learn about image inputs.
Detail BetaResponseInputImageDetailThe detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
type BetaResponseInputFile struct{…}A file input to the model.
A file input to the model.
Detail BetaResponseInputFileDetailOptionalThe detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.
The detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.
Role BetaEasyInputMessageRoleThe role of the message input. One of user, assistant, system, or
developer.
The role of the message input. One of user, assistant, system, or
developer.
Phase BetaEasyInputMessagePhaseOptionalLabels an assistant message as intermediate commentary (commentary) or the final answer (final_answer).
For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend
phase on all assistant messages — dropping it can degrade performance. Not used for user messages.
Labels an assistant message as intermediate commentary (commentary) or the final answer (final_answer).
For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend
phase on all assistant messages — dropping it can degrade performance. Not used for user messages.
type BetaResponseInputItemMessage struct{…}A message input to the model with a role indicating instruction following
hierarchy. Instructions given with the developer or system role take
precedence over instructions given with the user role.
A message input to the model with a role indicating instruction following
hierarchy. Instructions given with the developer or system role take
precedence over instructions given with the user role.
A list of one or many input items to the model, containing different content
types.
A list of one or many input items to the model, containing different content types.
type BetaResponseInputImage struct{…}An image input to the model. Learn about image inputs.
An image input to the model. Learn about image inputs.
Detail BetaResponseInputImageDetailThe detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
type BetaResponseInputFile struct{…}A file input to the model.
A file input to the model.
Detail BetaResponseInputFileDetailOptionalThe detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.
The detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.
type BetaResponseOutputMessage struct{…}An output message from the model.
An output message from the model.
Content []BetaResponseOutputMessageContentUnionThe content of the output message.
The content of the output message.
type BetaResponseOutputText struct{…}A text output from the model.
A text output from the model.
Annotations []BetaResponseOutputTextAnnotationUnionThe annotations of the text output.
The annotations of the text output.
type BetaResponseOutputTextAnnotationURLCitation struct{…}A citation for a web resource used to generate a model response.
A citation for a web resource used to generate a model response.
Status BetaResponseOutputMessageStatusThe status of the message input. One of in_progress, completed, or
incomplete. Populated when input items are returned via API.
The status of the message input. One of in_progress, completed, or
incomplete. Populated when input items are returned via API.
Phase BetaResponseOutputMessagePhaseOptionalLabels an assistant message as intermediate commentary (commentary) or the final answer (final_answer).
For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend
phase on all assistant messages — dropping it can degrade performance. Not used for user messages.
Labels an assistant message as intermediate commentary (commentary) or the final answer (final_answer).
For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend
phase on all assistant messages — dropping it can degrade performance. Not used for user messages.
type BetaResponseFileSearchToolCall struct{…}The results of a file search tool call. See the
file search guide for more information.
The results of a file search tool call. See the file search guide for more information.
Status BetaResponseFileSearchToolCallStatusThe status of the file search tool call. One of in_progress,
searching, incomplete or failed,
The status of the file search tool call. One of in_progress,
searching, incomplete or failed,
Results []BetaResponseFileSearchToolCallResultOptionalThe results of the file search tool call.
The results of the file search tool call.
Attributes map[string, BetaResponseFileSearchToolCallResultAttributeUnion]OptionalSet of 16 key-value pairs that can be attached to an object. This can be
useful for storing additional information about the object in a structured
format, and querying for objects via API or the dashboard. Keys are strings
with a maximum length of 64 characters. Values are strings with a maximum
length of 512 characters, booleans, or numbers.
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters, booleans, or numbers.
type BetaResponseComputerToolCall struct{…}A tool call to a computer use tool. See the
computer use guide for more information.
A tool call to a computer use tool. See the computer use guide for more information.
PendingSafetyChecks []BetaResponseComputerToolCallPendingSafetyCheckThe pending safety checks for the computer call.
The pending safety checks for the computer call.
Status BetaResponseComputerToolCallStatusThe status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
The status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
A click action.
A click action.
type BetaComputerActionClick struct{…}A click action.
A click action.
type BetaComputerActionDrag struct{…}A drag action.
A drag action.
type BetaComputerActionKeypress struct{…}A collection of keypresses the model would like to perform.
A collection of keypresses the model would like to perform.
Flattened batched actions for computer_use. Each action includes an
type discriminator and action-specific fields.
Flattened batched actions for computer_use. Each action includes an
type discriminator and action-specific fields.
type BetaComputerActionClick struct{…}A click action.
A click action.
type BetaComputerActionDrag struct{…}A drag action.
A drag action.
type BetaComputerActionKeypress struct{…}A collection of keypresses the model would like to perform.
A collection of keypresses the model would like to perform.
type BetaResponseInputItemComputerCallOutput struct{…}The output of a computer tool call.
The output of a computer tool call.
AcknowledgedSafetyChecks []BetaResponseInputItemComputerCallOutputAcknowledgedSafetyCheckOptionalThe safety checks reported by the API that have been acknowledged by the developer.
The safety checks reported by the API that have been acknowledged by the developer.
Status stringOptionalThe status of the message input. One of in_progress, completed, or incomplete. Populated when input items are returned via API.
The status of the message input. One of in_progress, completed, or incomplete. Populated when input items are returned via API.
type BetaResponseFunctionWebSearch struct{…}The results of a web search tool call. See the
web search guide for more information.
The results of a web search tool call. See the web search guide for more information.
Action BetaResponseFunctionWebSearchActionUnionAn object describing the specific action taken in this web search call.
Includes details on how the model used the web (search, open_page, find_in_page).
An object describing the specific action taken in this web search call. Includes details on how the model used the web (search, open_page, find_in_page).
Status BetaResponseFunctionWebSearchStatusThe status of the web search tool call.
The status of the web search tool call.
type BetaResponseFunctionToolCall struct{…}A tool call to run a function. See the
function calling guide for more information.
A tool call to run a function. See the function calling guide for more information.
Caller BetaResponseFunctionToolCallCallerUnionOptionalThe execution context that produced this tool call.
The execution context that produced this tool call.
type BetaResponseInputItemFunctionCallOutput struct{…}The output of a function tool call.
The output of a function tool call.
Output BetaResponseInputItemFunctionCallOutputOutputUnionText, image, or file output of the function tool call.
Text, image, or file output of the function tool call.
An array of content outputs (text, image, file) for the function tool call.
An array of content outputs (text, image, file) for the function tool call.
type BetaResponseInputTextContent struct{…}A text input to the model.
A text input to the model.
type BetaResponseInputImageContent struct{…}An image input to the model. Learn about image inputs
An image input to the model. Learn about image inputs
Detail BetaResponseInputImageContentDetailOptionalThe detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.
type BetaResponseInputFileContent struct{…}A file input to the model.
A file input to the model.
Detail BetaResponseInputFileContentDetailOptionalThe detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.
The detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.
The base64-encoded data of the file to be sent to the model.
The unique ID of the function tool call output. Populated when this item is returned via API.
Caller BetaResponseInputItemFunctionCallOutputCallerUnionOptionalThe execution context that produced this tool call.
The execution context that produced this tool call.
Status stringOptionalThe status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API.
The status of the item. One of in_progress, completed, or incomplete. Populated when items are returned via API.
type BetaResponseInputItemAgentMessage struct{…}A message routed between agents.
A message routed between agents.
Content []BetaResponseInputItemAgentMessageContentUnionPlaintext, image, or encrypted content sent between agents.
Plaintext, image, or encrypted content sent between agents.
type BetaResponseInputTextContent struct{…}A text input to the model.
A text input to the model.
type BetaResponseInputImageContent struct{…}An image input to the model. Learn about image inputs
An image input to the model. Learn about image inputs
Detail BetaResponseInputImageContentDetailOptionalThe detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
The URL of the image to be sent to the model. A fully qualified URL or base64 encoded image in a data URL.
type BetaResponseInputItemMultiAgentCall struct{…}
Action stringThe multi-agent action that was executed.
The multi-agent action that was executed.
type BetaResponseInputItemMultiAgentCallOutput struct{…}
Action stringThe multi-agent action that produced this result.
The multi-agent action that produced this result.
Output []BetaResponseInputItemMultiAgentCallOutputOutputText output returned by the multi-agent action.
Text output returned by the multi-agent action.
Annotations []BetaResponseInputItemMultiAgentCallOutputOutputAnnotationUnionOptionalCitations associated with the text content.
Citations associated with the text content.
type BetaResponseInputItemToolSearchCall struct{…}
The unique ID of the tool search call generated by the model.
Status stringOptionalThe status of the tool search call.
The status of the tool search call.
type BetaResponseToolSearchOutputItemParamResp struct{…}
Tools []BetaToolUnionThe loaded tool definitions returned by the tool search output.
The loaded tool definitions returned by the tool search output.
type BetaFunctionTool struct{…}Defines a function in your own code the model can choose to call. Learn more about function calling.
Defines a function in your own code the model can choose to call. Learn more about function calling.
type BetaFileSearchTool struct{…}A tool that searches for relevant content from uploaded files. Learn more about the file search tool.
A tool that searches for relevant content from uploaded files. Learn more about the file search tool.
Filters BetaFileSearchToolFiltersUnionOptionalA filter to apply.
A filter to apply.
type BetaFileSearchToolFiltersComparisonFilter struct{…}A filter used to compare a specified attribute key to a given value using a defined comparison operation.
A filter used to compare a specified attribute key to a given value using a defined comparison operation.
Type stringSpecifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equals
ne: not equal
gt: greater than
gte: greater than or equal
lt: less than
lte: less than or equal
in: in
nin: not in
Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equalsne: not equalgt: greater thangte: greater than or equallt: less thanlte: less than or equalin: innin: not in
type BetaFileSearchToolFiltersCompoundFilter struct{…}Combine multiple filters using and or or.
Combine multiple filters using and or or.
Filters []BetaFileSearchToolFiltersCompoundFilterFilterArray of filters to combine. Items can be ComparisonFilter or CompoundFilter.
Array of filters to combine. Items can be ComparisonFilter or CompoundFilter.
type BetaFileSearchToolFiltersCompoundFilterFilter struct{…}A filter used to compare a specified attribute key to a given value using a defined comparison operation.
A filter used to compare a specified attribute key to a given value using a defined comparison operation.
Type stringSpecifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equals
ne: not equal
gt: greater than
gte: greater than or equal
lt: less than
lte: less than or equal
in: in
nin: not in
Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equalsne: not equalgt: greater thangte: greater than or equallt: less thanlte: less than or equalin: innin: not in
The maximum number of results to return. This number should be between 1 and 50 inclusive.
RankingOptions BetaFileSearchToolRankingOptionsOptionalRanking options for search.
Ranking options for search.
type BetaComputerTool struct{…}A tool that controls a virtual computer. Learn more about the computer tool.
A tool that controls a virtual computer. Learn more about the computer tool.
type BetaComputerUsePreviewTool struct{…}A tool that controls a virtual computer. Learn more about the computer tool.
A tool that controls a virtual computer. Learn more about the computer tool.
type BetaWebSearchTool struct{…}Search the Internet for sources related to the prompt. Learn more about the
web search tool.
Search the Internet for sources related to the prompt. Learn more about the web search tool.
Type BetaWebSearchToolTypeThe type of the web search tool. One of web_search or web_search_2025_08_26.
The type of the web search tool. One of web_search or web_search_2025_08_26.
SearchContextSize BetaWebSearchToolSearchContextSizeOptionalHigh level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
UserLocation BetaWebSearchToolUserLocationOptionalThe approximate location of the user.
The approximate location of the user.
The two-letter ISO country code of the user, e.g. US.
The IANA timezone of the user, e.g. America/Los_Angeles.
type BetaToolMcp struct{…}Give the model access to additional tools via remote Model Context Protocol
(MCP) servers. Learn more about MCP.
Give the model access to additional tools via remote Model Context Protocol (MCP) servers. Learn more about MCP.
AllowedTools BetaToolMcpAllowedToolsUnionOptionalList of allowed tool names or a filter object.
List of allowed tool names or a filter object.
type BetaToolMcpAllowedToolsMcpToolFilter struct{…}A filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
An OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here.
ConnectorID stringOptionalIdentifier for service connectors, like those available in ChatGPT. One of
server_url, connector_id, or tunnel_id must be provided. Learn more
about service connectors here.
Currently supported connector_id values are:
- Dropbox:
connector_dropbox
- Gmail:
connector_gmail
- Google Calendar:
connector_googlecalendar
- Google Drive:
connector_googledrive
- Microsoft Teams:
connector_microsoftteams
- Outlook Calendar:
connector_outlookcalendar
- Outlook Email:
connector_outlookemail
- SharePoint:
connector_sharepoint
Identifier for service connectors, like those available in ChatGPT. One of
server_url, connector_id, or tunnel_id must be provided. Learn more
about service connectors here.
Currently supported connector_id values are:
- Dropbox:
connector_dropbox - Gmail:
connector_gmail - Google Calendar:
connector_googlecalendar - Google Drive:
connector_googledrive - Microsoft Teams:
connector_microsoftteams - Outlook Calendar:
connector_outlookcalendar - Outlook Email:
connector_outlookemail - SharePoint:
connector_sharepoint
Optional HTTP headers to send to the MCP server. Use for authentication or other purposes.
RequireApproval BetaToolMcpRequireApprovalUnionOptionalSpecify which of the MCP server’s tools require approval.
Specify which of the MCP server’s tools require approval.
type BetaToolMcpRequireApprovalMcpToolApprovalFilter struct{…}Specify which of the MCP server’s tools require approval. Can be
always, never, or a filter object associated with tools
that require approval.
Specify which of the MCP server’s tools require approval. Can be
always, never, or a filter object associated with tools
that require approval.
Always BetaToolMcpRequireApprovalMcpToolApprovalFilterAlwaysOptionalA filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
Never BetaToolMcpRequireApprovalMcpToolApprovalFilterNeverOptionalA filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
Optional description of the MCP server, used to provide more context.
type BetaToolCodeInterpreter struct{…}A tool that runs Python code to help generate a response to a prompt.
A tool that runs Python code to help generate a response to a prompt.
Container BetaToolCodeInterpreterContainerUnionThe code interpreter container. Can be a container ID or an object that
specifies uploaded file IDs to make available to your code, along with an
optional memory_limit setting.
The code interpreter container. Can be a container ID or an object that
specifies uploaded file IDs to make available to your code, along with an
optional memory_limit setting.
type BetaToolCodeInterpreterContainerCodeInterpreterToolAuto struct{…}Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
MemoryLimit stringOptionalThe memory limit for the code interpreter container.
The memory limit for the code interpreter container.
NetworkPolicy BetaToolCodeInterpreterContainerCodeInterpreterToolAutoNetworkPolicyUnionOptionalNetwork access policy for the container.
Network access policy for the container.
type BetaToolImageGeneration struct{…}A tool that generates images using the GPT image models.
A tool that generates images using the GPT image models.
Background stringOptionalAllows to set transparency for the background of the generated image(s).
This parameter is only supported for GPT image models that support
transparent backgrounds. Must be one of transparent, opaque, or
auto (default value). When auto is used, the model will
automatically determine the best background for the image.
gpt-image-2 and gpt-image-2-2026-04-21 do not support
transparent backgrounds. Requests with background set to
transparent will return an error for these models; use opaque or
auto instead.
If transparent, the output format needs to support transparency,
so it should be set to either png (default value) or webp.
Allows to set transparency for the background of the generated image(s).
This parameter is only supported for GPT image models that support
transparent backgrounds. Must be one of transparent, opaque, or
auto (default value). When auto is used, the model will
automatically determine the best background for the image.
gpt-image-2 and gpt-image-2-2026-04-21 do not support
transparent backgrounds. Requests with background set to
transparent will return an error for these models; use opaque or
auto instead.
If transparent, the output format needs to support transparency,
so it should be set to either png (default value) or webp.
InputFidelity stringOptionalControl how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.
Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.
InputImageMask BetaToolImageGenerationInputImageMaskOptionalOptional mask for inpainting. Contains image_url
(string, optional) and file_id (string, optional).
Optional mask for inpainting. Contains image_url
(string, optional) and file_id (string, optional).
Model stringOptionalThe image generation model to use. Default: gpt-image-1.
The image generation model to use. Default: gpt-image-1.
Compression level for the output image. Default: 100.
OutputFormat stringOptionalThe output format of the generated image. One of png, webp, or
jpeg. Default: png.
The output format of the generated image. One of png, webp, or
jpeg. Default: png.
Number of partial images to generate in streaming mode, from 0 (default value) to 3.
Quality stringOptionalThe quality of the generated image. One of low, medium, high,
or auto. Default: auto.
The quality of the generated image. One of low, medium, high,
or auto. Default: auto.
Size stringOptionalThe size of the generated images. For gpt-image-2 and gpt-image-2-2026-04-21, arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160. The requested size must also satisfy the model’s current pixel and edge limits. The standard sizes 1024x1024, 1536x1024, and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. For dall-e-2, use one of 256x256, 512x512, or 1024x1024. For dall-e-3, use one of 1024x1024, 1792x1024, or 1024x1792.
The size of the generated images. For gpt-image-2 and gpt-image-2-2026-04-21, arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160. The requested size must also satisfy the model’s current pixel and edge limits. The standard sizes 1024x1024, 1536x1024, and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. For dall-e-2, use one of 256x256, 512x512, or 1024x1024. For dall-e-3, use one of 1024x1024, 1792x1024, or 1024x1792.
type BetaToolLocalShell struct{…}A tool that allows the model to execute shell commands in a local environment.
A tool that allows the model to execute shell commands in a local environment.
type BetaFunctionShellTool struct{…}A tool that allows the model to execute shell commands.
A tool that allows the model to execute shell commands.
Environment BetaFunctionShellToolEnvironmentUnionOptional
type BetaContainerAuto struct{…}
MemoryLimit BetaContainerAutoMemoryLimitOptionalThe memory limit for the container.
The memory limit for the container.
NetworkPolicy BetaContainerAutoNetworkPolicyUnionOptionalNetwork access policy for the container.
Network access policy for the container.
Skills []BetaContainerAutoSkillUnionOptionalAn optional list of skills referenced by id or inline data.
An optional list of skills referenced by id or inline data.
type BetaInlineSkill struct{…}
Source BetaInlineSkillSourceInline skill payload
Inline skill payload
type BetaCustomTool struct{…}A custom tool that processes input using a specified format. Learn more about custom tools
A custom tool that processes input using a specified format. Learn more about custom tools
Format BetaCustomToolFormatUnionOptionalThe input format for the custom tool. Default is unconstrained text.
The input format for the custom tool. Default is unconstrained text.
type BetaNamespaceTool struct{…}Groups function/custom tools under a shared namespace.
Groups function/custom tools under a shared namespace.
Tools []BetaNamespaceToolToolUnionThe function/custom tools available inside this namespace.
The function/custom tools available inside this namespace.
type BetaNamespaceToolToolFunction struct{…}
type BetaCustomTool struct{…}A custom tool that processes input using a specified format. Learn more about custom tools
A custom tool that processes input using a specified format. Learn more about custom tools
Format BetaCustomToolFormatUnionOptionalThe input format for the custom tool. Default is unconstrained text.
The input format for the custom tool. Default is unconstrained text.
type BetaToolSearchTool struct{…}Hosted or BYOT tool search configuration for deferred tools.
Hosted or BYOT tool search configuration for deferred tools.
type BetaWebSearchPreviewTool struct{…}This tool searches the web for relevant results to use in a response. Learn more about the web search tool.
This tool searches the web for relevant results to use in a response. Learn more about the web search tool.
Type BetaWebSearchPreviewToolTypeThe type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11.
The type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11.
SearchContextSize BetaWebSearchPreviewToolSearchContextSizeOptionalHigh level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
UserLocation BetaWebSearchPreviewToolUserLocationOptionalThe user’s location.
The user’s location.
The two-letter ISO country code of the user, e.g. US.
The IANA timezone of the user, e.g. America/Los_Angeles.
The unique ID of the tool search call generated by the model.
Execution BetaResponseToolSearchOutputItemParamExecutionOptionalWhether tool search was executed by the server or by the client.
Whether tool search was executed by the server or by the client.
Status BetaResponseToolSearchOutputItemParamStatusOptionalThe status of the tool search output.
The status of the tool search output.
type BetaResponseInputItemAdditionalTools struct{…}
Tools []BetaToolUnionA list of additional tools made available at this item.
A list of additional tools made available at this item.
type BetaFunctionTool struct{…}Defines a function in your own code the model can choose to call. Learn more about function calling.
Defines a function in your own code the model can choose to call. Learn more about function calling.
type BetaFileSearchTool struct{…}A tool that searches for relevant content from uploaded files. Learn more about the file search tool.
A tool that searches for relevant content from uploaded files. Learn more about the file search tool.
Filters BetaFileSearchToolFiltersUnionOptionalA filter to apply.
A filter to apply.
type BetaFileSearchToolFiltersComparisonFilter struct{…}A filter used to compare a specified attribute key to a given value using a defined comparison operation.
A filter used to compare a specified attribute key to a given value using a defined comparison operation.
Type stringSpecifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equals
ne: not equal
gt: greater than
gte: greater than or equal
lt: less than
lte: less than or equal
in: in
nin: not in
Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equalsne: not equalgt: greater thangte: greater than or equallt: less thanlte: less than or equalin: innin: not in
type BetaFileSearchToolFiltersCompoundFilter struct{…}Combine multiple filters using and or or.
Combine multiple filters using and or or.
Filters []BetaFileSearchToolFiltersCompoundFilterFilterArray of filters to combine. Items can be ComparisonFilter or CompoundFilter.
Array of filters to combine. Items can be ComparisonFilter or CompoundFilter.
type BetaFileSearchToolFiltersCompoundFilterFilter struct{…}A filter used to compare a specified attribute key to a given value using a defined comparison operation.
A filter used to compare a specified attribute key to a given value using a defined comparison operation.
Type stringSpecifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equals
ne: not equal
gt: greater than
gte: greater than or equal
lt: less than
lte: less than or equal
in: in
nin: not in
Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equalsne: not equalgt: greater thangte: greater than or equallt: less thanlte: less than or equalin: innin: not in
The maximum number of results to return. This number should be between 1 and 50 inclusive.
RankingOptions BetaFileSearchToolRankingOptionsOptionalRanking options for search.
Ranking options for search.
type BetaComputerTool struct{…}A tool that controls a virtual computer. Learn more about the computer tool.
A tool that controls a virtual computer. Learn more about the computer tool.
type BetaComputerUsePreviewTool struct{…}A tool that controls a virtual computer. Learn more about the computer tool.
A tool that controls a virtual computer. Learn more about the computer tool.
type BetaWebSearchTool struct{…}Search the Internet for sources related to the prompt. Learn more about the
web search tool.
Search the Internet for sources related to the prompt. Learn more about the web search tool.
Type BetaWebSearchToolTypeThe type of the web search tool. One of web_search or web_search_2025_08_26.
The type of the web search tool. One of web_search or web_search_2025_08_26.
SearchContextSize BetaWebSearchToolSearchContextSizeOptionalHigh level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
UserLocation BetaWebSearchToolUserLocationOptionalThe approximate location of the user.
The approximate location of the user.
The two-letter ISO country code of the user, e.g. US.
The IANA timezone of the user, e.g. America/Los_Angeles.
type BetaToolMcp struct{…}Give the model access to additional tools via remote Model Context Protocol
(MCP) servers. Learn more about MCP.
Give the model access to additional tools via remote Model Context Protocol (MCP) servers. Learn more about MCP.
AllowedTools BetaToolMcpAllowedToolsUnionOptionalList of allowed tool names or a filter object.
List of allowed tool names or a filter object.
type BetaToolMcpAllowedToolsMcpToolFilter struct{…}A filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
An OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here.
ConnectorID stringOptionalIdentifier for service connectors, like those available in ChatGPT. One of
server_url, connector_id, or tunnel_id must be provided. Learn more
about service connectors here.
Currently supported connector_id values are:
- Dropbox:
connector_dropbox
- Gmail:
connector_gmail
- Google Calendar:
connector_googlecalendar
- Google Drive:
connector_googledrive
- Microsoft Teams:
connector_microsoftteams
- Outlook Calendar:
connector_outlookcalendar
- Outlook Email:
connector_outlookemail
- SharePoint:
connector_sharepoint
Identifier for service connectors, like those available in ChatGPT. One of
server_url, connector_id, or tunnel_id must be provided. Learn more
about service connectors here.
Currently supported connector_id values are:
- Dropbox:
connector_dropbox - Gmail:
connector_gmail - Google Calendar:
connector_googlecalendar - Google Drive:
connector_googledrive - Microsoft Teams:
connector_microsoftteams - Outlook Calendar:
connector_outlookcalendar - Outlook Email:
connector_outlookemail - SharePoint:
connector_sharepoint
Optional HTTP headers to send to the MCP server. Use for authentication or other purposes.
RequireApproval BetaToolMcpRequireApprovalUnionOptionalSpecify which of the MCP server’s tools require approval.
Specify which of the MCP server’s tools require approval.
type BetaToolMcpRequireApprovalMcpToolApprovalFilter struct{…}Specify which of the MCP server’s tools require approval. Can be
always, never, or a filter object associated with tools
that require approval.
Specify which of the MCP server’s tools require approval. Can be
always, never, or a filter object associated with tools
that require approval.
Always BetaToolMcpRequireApprovalMcpToolApprovalFilterAlwaysOptionalA filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
Never BetaToolMcpRequireApprovalMcpToolApprovalFilterNeverOptionalA filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
Optional description of the MCP server, used to provide more context.
type BetaToolCodeInterpreter struct{…}A tool that runs Python code to help generate a response to a prompt.
A tool that runs Python code to help generate a response to a prompt.
Container BetaToolCodeInterpreterContainerUnionThe code interpreter container. Can be a container ID or an object that
specifies uploaded file IDs to make available to your code, along with an
optional memory_limit setting.
The code interpreter container. Can be a container ID or an object that
specifies uploaded file IDs to make available to your code, along with an
optional memory_limit setting.
type BetaToolCodeInterpreterContainerCodeInterpreterToolAuto struct{…}Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
MemoryLimit stringOptionalThe memory limit for the code interpreter container.
The memory limit for the code interpreter container.
NetworkPolicy BetaToolCodeInterpreterContainerCodeInterpreterToolAutoNetworkPolicyUnionOptionalNetwork access policy for the container.
Network access policy for the container.
type BetaToolImageGeneration struct{…}A tool that generates images using the GPT image models.
A tool that generates images using the GPT image models.
Background stringOptionalAllows to set transparency for the background of the generated image(s).
This parameter is only supported for GPT image models that support
transparent backgrounds. Must be one of transparent, opaque, or
auto (default value). When auto is used, the model will
automatically determine the best background for the image.
gpt-image-2 and gpt-image-2-2026-04-21 do not support
transparent backgrounds. Requests with background set to
transparent will return an error for these models; use opaque or
auto instead.
If transparent, the output format needs to support transparency,
so it should be set to either png (default value) or webp.
Allows to set transparency for the background of the generated image(s).
This parameter is only supported for GPT image models that support
transparent backgrounds. Must be one of transparent, opaque, or
auto (default value). When auto is used, the model will
automatically determine the best background for the image.
gpt-image-2 and gpt-image-2-2026-04-21 do not support
transparent backgrounds. Requests with background set to
transparent will return an error for these models; use opaque or
auto instead.
If transparent, the output format needs to support transparency,
so it should be set to either png (default value) or webp.
InputFidelity stringOptionalControl how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.
Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.
InputImageMask BetaToolImageGenerationInputImageMaskOptionalOptional mask for inpainting. Contains image_url
(string, optional) and file_id (string, optional).
Optional mask for inpainting. Contains image_url
(string, optional) and file_id (string, optional).
Model stringOptionalThe image generation model to use. Default: gpt-image-1.
The image generation model to use. Default: gpt-image-1.
Compression level for the output image. Default: 100.
OutputFormat stringOptionalThe output format of the generated image. One of png, webp, or
jpeg. Default: png.
The output format of the generated image. One of png, webp, or
jpeg. Default: png.
Number of partial images to generate in streaming mode, from 0 (default value) to 3.
Quality stringOptionalThe quality of the generated image. One of low, medium, high,
or auto. Default: auto.
The quality of the generated image. One of low, medium, high,
or auto. Default: auto.
Size stringOptionalThe size of the generated images. For gpt-image-2 and gpt-image-2-2026-04-21, arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160. The requested size must also satisfy the model’s current pixel and edge limits. The standard sizes 1024x1024, 1536x1024, and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. For dall-e-2, use one of 256x256, 512x512, or 1024x1024. For dall-e-3, use one of 1024x1024, 1792x1024, or 1024x1792.
The size of the generated images. For gpt-image-2 and gpt-image-2-2026-04-21, arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160. The requested size must also satisfy the model’s current pixel and edge limits. The standard sizes 1024x1024, 1536x1024, and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. For dall-e-2, use one of 256x256, 512x512, or 1024x1024. For dall-e-3, use one of 1024x1024, 1792x1024, or 1024x1792.
type BetaToolLocalShell struct{…}A tool that allows the model to execute shell commands in a local environment.
A tool that allows the model to execute shell commands in a local environment.
type BetaFunctionShellTool struct{…}A tool that allows the model to execute shell commands.
A tool that allows the model to execute shell commands.
Environment BetaFunctionShellToolEnvironmentUnionOptional
type BetaContainerAuto struct{…}
MemoryLimit BetaContainerAutoMemoryLimitOptionalThe memory limit for the container.
The memory limit for the container.
NetworkPolicy BetaContainerAutoNetworkPolicyUnionOptionalNetwork access policy for the container.
Network access policy for the container.
Skills []BetaContainerAutoSkillUnionOptionalAn optional list of skills referenced by id or inline data.
An optional list of skills referenced by id or inline data.
type BetaInlineSkill struct{…}
Source BetaInlineSkillSourceInline skill payload
Inline skill payload
type BetaCustomTool struct{…}A custom tool that processes input using a specified format. Learn more about custom tools
A custom tool that processes input using a specified format. Learn more about custom tools
Format BetaCustomToolFormatUnionOptionalThe input format for the custom tool. Default is unconstrained text.
The input format for the custom tool. Default is unconstrained text.
type BetaNamespaceTool struct{…}Groups function/custom tools under a shared namespace.
Groups function/custom tools under a shared namespace.
Tools []BetaNamespaceToolToolUnionThe function/custom tools available inside this namespace.
The function/custom tools available inside this namespace.
type BetaNamespaceToolToolFunction struct{…}
type BetaCustomTool struct{…}A custom tool that processes input using a specified format. Learn more about custom tools
A custom tool that processes input using a specified format. Learn more about custom tools
Format BetaCustomToolFormatUnionOptionalThe input format for the custom tool. Default is unconstrained text.
The input format for the custom tool. Default is unconstrained text.
type BetaToolSearchTool struct{…}Hosted or BYOT tool search configuration for deferred tools.
Hosted or BYOT tool search configuration for deferred tools.
type BetaWebSearchPreviewTool struct{…}This tool searches the web for relevant results to use in a response. Learn more about the web search tool.
This tool searches the web for relevant results to use in a response. Learn more about the web search tool.
Type BetaWebSearchPreviewToolTypeThe type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11.
The type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11.
SearchContextSize BetaWebSearchPreviewToolSearchContextSizeOptionalHigh level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
UserLocation BetaWebSearchPreviewToolUserLocationOptionalThe user’s location.
The user’s location.
The two-letter ISO country code of the user, e.g. US.
The IANA timezone of the user, e.g. America/Los_Angeles.
type BetaResponseReasoningItem struct{…}A description of the chain of thought used by a reasoning model while generating
a response. Be sure to include these items in your input to the Responses API
for subsequent turns of a conversation if you are manually
managing context.
A description of the chain of thought used by a reasoning model while generating
a response. Be sure to include these items in your input to the Responses API
for subsequent turns of a conversation if you are manually
managing context.
The encrypted content of the reasoning item. This is populated by default
for reasoning items returned by POST /v1/responses and WebSocket
response.create requests.
type BetaResponseCompactionItemParamResp struct{…}A compaction item generated by the v1/responses/compact API.
A compaction item generated by the v1/responses/compact API.
type BetaResponseInputItemImageGenerationCall struct{…}An image generation request made by the model.
An image generation request made by the model.
Status stringThe status of the image generation call.
The status of the image generation call.
type BetaResponseCodeInterpreterToolCall struct{…}A tool call to run code.
A tool call to run code.
Outputs []BetaResponseCodeInterpreterToolCallOutputUnionThe outputs generated by the code interpreter, such as logs or images.
Can be null if no outputs are available.
The outputs generated by the code interpreter, such as logs or images. Can be null if no outputs are available.
Status BetaResponseCodeInterpreterToolCallStatusThe status of the code interpreter tool call. Valid values are in_progress, completed, incomplete, interpreting, and failed.
The status of the code interpreter tool call. Valid values are in_progress, completed, incomplete, interpreting, and failed.
type BetaResponseInputItemLocalShellCall struct{…}A tool call to run a command on the local shell.
A tool call to run a command on the local shell.
type BetaResponseInputItemLocalShellCallOutput struct{…}The output of a local shell tool call.
The output of a local shell tool call.
The type of the local shell tool call output. Always local_shell_call_output.
Status stringOptionalThe status of the item. One of in_progress, completed, or incomplete.
The status of the item. One of in_progress, completed, or incomplete.
type BetaResponseInputItemShellCall struct{…}A tool representing a request to execute one or more shell commands.
A tool representing a request to execute one or more shell commands.
Action BetaResponseInputItemShellCallActionThe shell commands and limits that describe how to run the tool call.
The shell commands and limits that describe how to run the tool call.
The unique ID of the shell tool call. Populated when this item is returned via API.
Caller BetaResponseInputItemShellCallCallerUnionOptionalThe execution context that produced this tool call.
The execution context that produced this tool call.
Environment BetaResponseInputItemShellCallEnvironmentUnionOptionalThe environment to execute the shell commands in.
The environment to execute the shell commands in.
Status stringOptionalThe status of the shell call. One of in_progress, completed, or incomplete.
The status of the shell call. One of in_progress, completed, or incomplete.
type BetaResponseInputItemShellCallOutput struct{…}The streamed output items emitted by a shell tool call.
The streamed output items emitted by a shell tool call.
Captured chunks of stdout and stderr output, along with their associated outcomes.
Captured chunks of stdout and stderr output, along with their associated outcomes.
The unique ID of the shell tool call output. Populated when this item is returned via API.
Caller BetaResponseInputItemShellCallOutputCallerUnionOptionalThe execution context that produced this tool call.
The execution context that produced this tool call.
The maximum number of UTF-8 characters captured for this shell call’s combined output.
Status stringOptionalThe status of the shell call output.
The status of the shell call output.
type BetaResponseInputItemApplyPatchCall struct{…}A tool call representing a request to create, delete, or update files using diff patches.
A tool call representing a request to create, delete, or update files using diff patches.
The unique ID of the apply patch tool call generated by the model.
Operation BetaResponseInputItemApplyPatchCallOperationUnionThe specific create, delete, or update instruction for the apply_patch tool call.
The specific create, delete, or update instruction for the apply_patch tool call.
type BetaResponseInputItemApplyPatchCallOperationCreateFile struct{…}Instruction for creating a new file via the apply_patch tool.
Instruction for creating a new file via the apply_patch tool.
type BetaResponseInputItemApplyPatchCallOperationDeleteFile struct{…}Instruction for deleting an existing file via the apply_patch tool.
Instruction for deleting an existing file via the apply_patch tool.
The unique ID of the apply patch tool call. Populated when this item is returned via API.
type BetaResponseInputItemApplyPatchCallOutput struct{…}The streamed output emitted by an apply patch tool call.
The streamed output emitted by an apply patch tool call.
The unique ID of the apply patch tool call generated by the model.
The unique ID of the apply patch tool call output. Populated when this item is returned via API.
type BetaResponseInputItemMcpListTools struct{…}A list of tools available on an MCP server.
A list of tools available on an MCP server.
type BetaResponseInputItemMcpApprovalRequest struct{…}A request for human approval of a tool invocation.
A request for human approval of a tool invocation.
type BetaResponseInputItemMcpApprovalResponse struct{…}A response to an MCP approval request.
A response to an MCP approval request.
type BetaResponseInputItemMcpCall struct{…}An invocation of a tool on an MCP server.
An invocation of a tool on an MCP server.
Unique identifier for the MCP tool call approval request.
Include this value in a subsequent mcp_approval_response input to approve or reject the corresponding tool call.
Status stringOptionalThe status of the tool call. One of in_progress, completed, incomplete, calling, or failed.
The status of the tool call. One of in_progress, completed, incomplete, calling, or failed.
type BetaResponseCustomToolCallOutput struct{…}The output of a custom tool call from your code, being sent back to the model.
The output of a custom tool call from your code, being sent back to the model.
Output BetaResponseCustomToolCallOutputOutputUnionThe output from the custom tool call generated by your code.
Can be a string or an list of output content.
The output from the custom tool call generated by your code. Can be a string or an list of output content.
type BetaResponseCustomToolCallOutputOutputOutputContentList []BetaResponseCustomToolCallOutputOutputOutputContentListItemUnionText, image, or file output of the custom tool call.
Text, image, or file output of the custom tool call.
type BetaResponseInputImage struct{…}An image input to the model. Learn about image inputs.
An image input to the model. Learn about image inputs.
Detail BetaResponseInputImageDetailThe detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
type BetaResponseInputFile struct{…}A file input to the model.
A file input to the model.
Detail BetaResponseInputFileDetailOptionalThe detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.
The detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.
type BetaResponseCustomToolCall struct{…}A call to a custom tool created by the model.
A call to a custom tool created by the model.
type BetaResponseInputItemCompactionTrigger struct{…}Compacts the current context. Must be the final input item.
Compacts the current context. Must be the final input item.
Body param: A system (or developer) message inserted into the model’s context.
When used along with previous_response_id, the instructions from a previous response will not be carried over to the next response. This makes it simple to swap out system (or developer) messages in new responses.
Body param: The unique ID of the previous response to the model. Use this to create multi-turn conversations. Learn more about conversation state. Cannot be used in conjunction with conversation.
Body param: A key to use when reading from or writing to the prompt cache.
Body param: Options for prompt caching. Supported for gpt-5.6 and later models. By default, OpenAI automatically chooses one implicit cache breakpoint. You can add explicit breakpoints to content blocks with prompt_cache_breakpoint. Each request can write up to four breakpoints. For cache matching, OpenAI considers up to the latest 80 breakpoints in the conversation, without a content-block lookback limit. Set mode to explicit to disable the implicit breakpoint. The ttl defaults to 30m, which is currently the only supported value. See the prompt caching guide for current details.
Body param: Options for prompt caching. Supported for gpt-5.6 and later models. By default, OpenAI automatically chooses one implicit cache breakpoint. You can add explicit breakpoints to content blocks with prompt_cache_breakpoint. Each request can write up to four breakpoints. For cache matching, OpenAI considers up to the latest 80 breakpoints in the conversation, without a content-block lookback limit. Set mode to explicit to disable the implicit breakpoint. The ttl defaults to 30m, which is currently the only supported value. See the prompt caching guide for current details.
Mode stringOptionalControls whether OpenAI automatically creates an implicit cache breakpoint. Defaults to implicit. With implicit, OpenAI creates one implicit breakpoint and writes up to the latest three explicit breakpoints in the request. With explicit, OpenAI does not create an implicit breakpoint and writes up to the latest four explicit breakpoints. If there are no explicit breakpoints, the request does not use prompt caching.
Controls whether OpenAI automatically creates an implicit cache breakpoint. Defaults to implicit. With implicit, OpenAI creates one implicit breakpoint and writes up to the latest three explicit breakpoints in the request. With explicit, OpenAI does not create an implicit breakpoint and writes up to the latest four explicit breakpoints. If there are no explicit breakpoints, the request does not use prompt caching.
Body param: How long to retain a prompt cache entry created by this request.
Body param: How long to retain a prompt cache entry created by this request.
Body param: The service tier to use for this request.
Body param: The service tier to use for this request.
ReturnsExpand Collapse
type BetaCompactedResponse struct{…}
Unix timestamp (in seconds) when the compacted conversation was created.
Output []BetaResponseOutputItemUnionThe compacted list of output items. This is a list of all user messages, followed by a single compaction item.
The compacted list of output items. This is a list of all user messages, followed by a single compaction item.
type BetaResponseOutputMessage struct{…}An output message from the model.
An output message from the model.
Content []BetaResponseOutputMessageContentUnionThe content of the output message.
The content of the output message.
type BetaResponseOutputText struct{…}A text output from the model.
A text output from the model.
Annotations []BetaResponseOutputTextAnnotationUnionThe annotations of the text output.
The annotations of the text output.
type BetaResponseOutputTextAnnotationURLCitation struct{…}A citation for a web resource used to generate a model response.
A citation for a web resource used to generate a model response.
Status BetaResponseOutputMessageStatusThe status of the message input. One of in_progress, completed, or
incomplete. Populated when input items are returned via API.
The status of the message input. One of in_progress, completed, or
incomplete. Populated when input items are returned via API.
Phase BetaResponseOutputMessagePhaseOptionalLabels an assistant message as intermediate commentary (commentary) or the final answer (final_answer).
For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend
phase on all assistant messages — dropping it can degrade performance. Not used for user messages.
Labels an assistant message as intermediate commentary (commentary) or the final answer (final_answer).
For models like gpt-5.3-codex and beyond, when sending follow-up requests, preserve and resend
phase on all assistant messages — dropping it can degrade performance. Not used for user messages.
type BetaResponseFileSearchToolCall struct{…}The results of a file search tool call. See the
file search guide for more information.
The results of a file search tool call. See the file search guide for more information.
Status BetaResponseFileSearchToolCallStatusThe status of the file search tool call. One of in_progress,
searching, incomplete or failed,
The status of the file search tool call. One of in_progress,
searching, incomplete or failed,
Results []BetaResponseFileSearchToolCallResultOptionalThe results of the file search tool call.
The results of the file search tool call.
Attributes map[string, BetaResponseFileSearchToolCallResultAttributeUnion]OptionalSet of 16 key-value pairs that can be attached to an object. This can be
useful for storing additional information about the object in a structured
format, and querying for objects via API or the dashboard. Keys are strings
with a maximum length of 64 characters. Values are strings with a maximum
length of 512 characters, booleans, or numbers.
Set of 16 key-value pairs that can be attached to an object. This can be useful for storing additional information about the object in a structured format, and querying for objects via API or the dashboard. Keys are strings with a maximum length of 64 characters. Values are strings with a maximum length of 512 characters, booleans, or numbers.
type BetaResponseFunctionToolCall struct{…}A tool call to run a function. See the
function calling guide for more information.
A tool call to run a function. See the function calling guide for more information.
Caller BetaResponseFunctionToolCallCallerUnionOptionalThe execution context that produced this tool call.
The execution context that produced this tool call.
type BetaResponseFunctionToolCallOutputItem struct{…}
Output BetaResponseFunctionToolCallOutputItemOutputUnionThe output from the function call generated by your code.
Can be a string or an list of output content.
The output from the function call generated by your code. Can be a string or an list of output content.
type BetaResponseFunctionToolCallOutputItemOutputOutputContentList []BetaResponseFunctionToolCallOutputItemOutputOutputContentListItemUnionText, image, or file output of the function call.
Text, image, or file output of the function call.
type BetaResponseInputImage struct{…}An image input to the model. Learn about image inputs.
An image input to the model. Learn about image inputs.
Detail BetaResponseInputImageDetailThe detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
type BetaResponseInputFile struct{…}A file input to the model.
A file input to the model.
Detail BetaResponseInputFileDetailOptionalThe detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.
The detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.
Status BetaResponseFunctionToolCallOutputItemStatusThe status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
The status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
type BetaResponseOutputItemAgentMessage struct{…}
Content []BetaResponseOutputItemAgentMessageContentUnionEncrypted content sent between agents.
Encrypted content sent between agents.
type BetaResponseOutputText struct{…}A text output from the model.
A text output from the model.
Annotations []BetaResponseOutputTextAnnotationUnionThe annotations of the text output.
The annotations of the text output.
type BetaResponseOutputTextAnnotationURLCitation struct{…}A citation for a web resource used to generate a model response.
A citation for a web resource used to generate a model response.
type BetaResponseInputImage struct{…}An image input to the model. Learn about image inputs.
An image input to the model. Learn about image inputs.
Detail BetaResponseInputImageDetailThe detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
The detail level of the image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
type BetaResponseOutputItemAgentMessageContentComputerScreenshot struct{…}A screenshot of a computer.
A screenshot of a computer.
Detail stringThe detail level of the screenshot image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
The detail level of the screenshot image to be sent to the model. One of high, low, auto, or original. Defaults to auto.
Specifies the event type. For a computer screenshot, this property is always set to computer_screenshot.
type BetaResponseInputFile struct{…}A file input to the model.
A file input to the model.
Detail BetaResponseInputFileDetailOptionalThe detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.
The detail level of the file to be sent to the model. Use auto to let the system select the detail level; for GPT-5.6 and later models, auto uses high-quality rendering, which may increase input token usage. Use low for lower-cost rendering, or high to render the file at higher quality. Defaults to auto.
type BetaResponseOutputItemMultiAgentCall struct{…}
Action stringThe multi-agent action to execute.
The multi-agent action to execute.
type BetaResponseOutputItemMultiAgentCallOutput struct{…}
Action stringThe multi-agent action that produced this result.
The multi-agent action that produced this result.
Output []BetaResponseOutputTextText output returned by the multi-agent action.
Text output returned by the multi-agent action.
Annotations []BetaResponseOutputTextAnnotationUnionThe annotations of the text output.
The annotations of the text output.
type BetaResponseOutputTextAnnotationURLCitation struct{…}A citation for a web resource used to generate a model response.
A citation for a web resource used to generate a model response.
type BetaResponseFunctionWebSearch struct{…}The results of a web search tool call. See the
web search guide for more information.
The results of a web search tool call. See the web search guide for more information.
Action BetaResponseFunctionWebSearchActionUnionAn object describing the specific action taken in this web search call.
Includes details on how the model used the web (search, open_page, find_in_page).
An object describing the specific action taken in this web search call. Includes details on how the model used the web (search, open_page, find_in_page).
Status BetaResponseFunctionWebSearchStatusThe status of the web search tool call.
The status of the web search tool call.
type BetaResponseComputerToolCall struct{…}A tool call to a computer use tool. See the
computer use guide for more information.
A tool call to a computer use tool. See the computer use guide for more information.
PendingSafetyChecks []BetaResponseComputerToolCallPendingSafetyCheckThe pending safety checks for the computer call.
The pending safety checks for the computer call.
Status BetaResponseComputerToolCallStatusThe status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
The status of the item. One of in_progress, completed, or
incomplete. Populated when items are returned via API.
A click action.
A click action.
type BetaComputerActionClick struct{…}A click action.
A click action.
type BetaComputerActionDrag struct{…}A drag action.
A drag action.
type BetaComputerActionKeypress struct{…}A collection of keypresses the model would like to perform.
A collection of keypresses the model would like to perform.
Flattened batched actions for computer_use. Each action includes an
type discriminator and action-specific fields.
Flattened batched actions for computer_use. Each action includes an
type discriminator and action-specific fields.
type BetaComputerActionClick struct{…}A click action.
A click action.
type BetaComputerActionDrag struct{…}A drag action.
A drag action.
type BetaComputerActionKeypress struct{…}A collection of keypresses the model would like to perform.
A collection of keypresses the model would like to perform.
type BetaResponseComputerToolCallOutputItem struct{…}
Status BetaResponseComputerToolCallOutputItemStatusThe status of the message input. One of in_progress, completed, or
incomplete. Populated when input items are returned via API.
The status of the message input. One of in_progress, completed, or
incomplete. Populated when input items are returned via API.
AcknowledgedSafetyChecks []BetaResponseComputerToolCallOutputItemAcknowledgedSafetyCheckOptionalThe safety checks reported by the API that have been acknowledged by the
developer.
The safety checks reported by the API that have been acknowledged by the developer.
type BetaResponseReasoningItem struct{…}A description of the chain of thought used by a reasoning model while generating
a response. Be sure to include these items in your input to the Responses API
for subsequent turns of a conversation if you are manually
managing context.
A description of the chain of thought used by a reasoning model while generating
a response. Be sure to include these items in your input to the Responses API
for subsequent turns of a conversation if you are manually
managing context.
The encrypted content of the reasoning item. This is populated by default
for reasoning items returned by POST /v1/responses and WebSocket
response.create requests.
type BetaResponseOutputItemProgramOutput struct{…}
type BetaResponseToolSearchCall struct{…}
Execution BetaResponseToolSearchCallExecutionWhether tool search was executed by the server or by the client.
Whether tool search was executed by the server or by the client.
Status BetaResponseToolSearchCallStatusThe status of the tool search call item that was recorded.
The status of the tool search call item that was recorded.
type BetaResponseToolSearchOutputItem struct{…}
Execution BetaResponseToolSearchOutputItemExecutionWhether tool search was executed by the server or by the client.
Whether tool search was executed by the server or by the client.
Status BetaResponseToolSearchOutputItemStatusThe status of the tool search output item that was recorded.
The status of the tool search output item that was recorded.
Tools []BetaToolUnionThe loaded tool definitions returned by tool search.
The loaded tool definitions returned by tool search.
type BetaFunctionTool struct{…}Defines a function in your own code the model can choose to call. Learn more about function calling.
Defines a function in your own code the model can choose to call. Learn more about function calling.
type BetaFileSearchTool struct{…}A tool that searches for relevant content from uploaded files. Learn more about the file search tool.
A tool that searches for relevant content from uploaded files. Learn more about the file search tool.
Filters BetaFileSearchToolFiltersUnionOptionalA filter to apply.
A filter to apply.
type BetaFileSearchToolFiltersComparisonFilter struct{…}A filter used to compare a specified attribute key to a given value using a defined comparison operation.
A filter used to compare a specified attribute key to a given value using a defined comparison operation.
Type stringSpecifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equals
ne: not equal
gt: greater than
gte: greater than or equal
lt: less than
lte: less than or equal
in: in
nin: not in
Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equalsne: not equalgt: greater thangte: greater than or equallt: less thanlte: less than or equalin: innin: not in
type BetaFileSearchToolFiltersCompoundFilter struct{…}Combine multiple filters using and or or.
Combine multiple filters using and or or.
Filters []BetaFileSearchToolFiltersCompoundFilterFilterArray of filters to combine. Items can be ComparisonFilter or CompoundFilter.
Array of filters to combine. Items can be ComparisonFilter or CompoundFilter.
type BetaFileSearchToolFiltersCompoundFilterFilter struct{…}A filter used to compare a specified attribute key to a given value using a defined comparison operation.
A filter used to compare a specified attribute key to a given value using a defined comparison operation.
Type stringSpecifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equals
ne: not equal
gt: greater than
gte: greater than or equal
lt: less than
lte: less than or equal
in: in
nin: not in
Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equalsne: not equalgt: greater thangte: greater than or equallt: less thanlte: less than or equalin: innin: not in
The maximum number of results to return. This number should be between 1 and 50 inclusive.
RankingOptions BetaFileSearchToolRankingOptionsOptionalRanking options for search.
Ranking options for search.
type BetaComputerTool struct{…}A tool that controls a virtual computer. Learn more about the computer tool.
A tool that controls a virtual computer. Learn more about the computer tool.
type BetaComputerUsePreviewTool struct{…}A tool that controls a virtual computer. Learn more about the computer tool.
A tool that controls a virtual computer. Learn more about the computer tool.
type BetaWebSearchTool struct{…}Search the Internet for sources related to the prompt. Learn more about the
web search tool.
Search the Internet for sources related to the prompt. Learn more about the web search tool.
Type BetaWebSearchToolTypeThe type of the web search tool. One of web_search or web_search_2025_08_26.
The type of the web search tool. One of web_search or web_search_2025_08_26.
SearchContextSize BetaWebSearchToolSearchContextSizeOptionalHigh level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
UserLocation BetaWebSearchToolUserLocationOptionalThe approximate location of the user.
The approximate location of the user.
The two-letter ISO country code of the user, e.g. US.
The IANA timezone of the user, e.g. America/Los_Angeles.
type BetaToolMcp struct{…}Give the model access to additional tools via remote Model Context Protocol
(MCP) servers. Learn more about MCP.
Give the model access to additional tools via remote Model Context Protocol (MCP) servers. Learn more about MCP.
AllowedTools BetaToolMcpAllowedToolsUnionOptionalList of allowed tool names or a filter object.
List of allowed tool names or a filter object.
type BetaToolMcpAllowedToolsMcpToolFilter struct{…}A filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
An OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here.
ConnectorID stringOptionalIdentifier for service connectors, like those available in ChatGPT. One of
server_url, connector_id, or tunnel_id must be provided. Learn more
about service connectors here.
Currently supported connector_id values are:
- Dropbox:
connector_dropbox
- Gmail:
connector_gmail
- Google Calendar:
connector_googlecalendar
- Google Drive:
connector_googledrive
- Microsoft Teams:
connector_microsoftteams
- Outlook Calendar:
connector_outlookcalendar
- Outlook Email:
connector_outlookemail
- SharePoint:
connector_sharepoint
Identifier for service connectors, like those available in ChatGPT. One of
server_url, connector_id, or tunnel_id must be provided. Learn more
about service connectors here.
Currently supported connector_id values are:
- Dropbox:
connector_dropbox - Gmail:
connector_gmail - Google Calendar:
connector_googlecalendar - Google Drive:
connector_googledrive - Microsoft Teams:
connector_microsoftteams - Outlook Calendar:
connector_outlookcalendar - Outlook Email:
connector_outlookemail - SharePoint:
connector_sharepoint
Optional HTTP headers to send to the MCP server. Use for authentication or other purposes.
RequireApproval BetaToolMcpRequireApprovalUnionOptionalSpecify which of the MCP server’s tools require approval.
Specify which of the MCP server’s tools require approval.
type BetaToolMcpRequireApprovalMcpToolApprovalFilter struct{…}Specify which of the MCP server’s tools require approval. Can be
always, never, or a filter object associated with tools
that require approval.
Specify which of the MCP server’s tools require approval. Can be
always, never, or a filter object associated with tools
that require approval.
Always BetaToolMcpRequireApprovalMcpToolApprovalFilterAlwaysOptionalA filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
Never BetaToolMcpRequireApprovalMcpToolApprovalFilterNeverOptionalA filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
Optional description of the MCP server, used to provide more context.
type BetaToolCodeInterpreter struct{…}A tool that runs Python code to help generate a response to a prompt.
A tool that runs Python code to help generate a response to a prompt.
Container BetaToolCodeInterpreterContainerUnionThe code interpreter container. Can be a container ID or an object that
specifies uploaded file IDs to make available to your code, along with an
optional memory_limit setting.
The code interpreter container. Can be a container ID or an object that
specifies uploaded file IDs to make available to your code, along with an
optional memory_limit setting.
type BetaToolCodeInterpreterContainerCodeInterpreterToolAuto struct{…}Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
MemoryLimit stringOptionalThe memory limit for the code interpreter container.
The memory limit for the code interpreter container.
NetworkPolicy BetaToolCodeInterpreterContainerCodeInterpreterToolAutoNetworkPolicyUnionOptionalNetwork access policy for the container.
Network access policy for the container.
type BetaToolImageGeneration struct{…}A tool that generates images using the GPT image models.
A tool that generates images using the GPT image models.
Background stringOptionalAllows to set transparency for the background of the generated image(s).
This parameter is only supported for GPT image models that support
transparent backgrounds. Must be one of transparent, opaque, or
auto (default value). When auto is used, the model will
automatically determine the best background for the image.
gpt-image-2 and gpt-image-2-2026-04-21 do not support
transparent backgrounds. Requests with background set to
transparent will return an error for these models; use opaque or
auto instead.
If transparent, the output format needs to support transparency,
so it should be set to either png (default value) or webp.
Allows to set transparency for the background of the generated image(s).
This parameter is only supported for GPT image models that support
transparent backgrounds. Must be one of transparent, opaque, or
auto (default value). When auto is used, the model will
automatically determine the best background for the image.
gpt-image-2 and gpt-image-2-2026-04-21 do not support
transparent backgrounds. Requests with background set to
transparent will return an error for these models; use opaque or
auto instead.
If transparent, the output format needs to support transparency,
so it should be set to either png (default value) or webp.
InputFidelity stringOptionalControl how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.
Control how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.
InputImageMask BetaToolImageGenerationInputImageMaskOptionalOptional mask for inpainting. Contains image_url
(string, optional) and file_id (string, optional).
Optional mask for inpainting. Contains image_url
(string, optional) and file_id (string, optional).
Model stringOptionalThe image generation model to use. Default: gpt-image-1.
The image generation model to use. Default: gpt-image-1.
Compression level for the output image. Default: 100.
OutputFormat stringOptionalThe output format of the generated image. One of png, webp, or
jpeg. Default: png.
The output format of the generated image. One of png, webp, or
jpeg. Default: png.
Number of partial images to generate in streaming mode, from 0 (default value) to 3.
Quality stringOptionalThe quality of the generated image. One of low, medium, high,
or auto. Default: auto.
The quality of the generated image. One of low, medium, high,
or auto. Default: auto.
Size stringOptionalThe size of the generated images. For gpt-image-2 and gpt-image-2-2026-04-21, arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160. The requested size must also satisfy the model’s current pixel and edge limits. The standard sizes 1024x1024, 1536x1024, and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. For dall-e-2, use one of 256x256, 512x512, or 1024x1024. For dall-e-3, use one of 1024x1024, 1792x1024, or 1024x1792.
The size of the generated images. For gpt-image-2 and gpt-image-2-2026-04-21, arbitrary resolutions are supported as WIDTHxHEIGHT strings, for example 1536x864. Width and height must both be divisible by 16 and the requested aspect ratio must be between 1:3 and 3:1. Resolutions above 2560x1440 are experimental, and the maximum supported resolution is 3840x2160. The requested size must also satisfy the model’s current pixel and edge limits. The standard sizes 1024x1024, 1536x1024, and 1024x1536 are supported by the GPT image models; auto is supported for models that allow automatic sizing. For dall-e-2, use one of 256x256, 512x512, or 1024x1024. For dall-e-3, use one of 1024x1024, 1792x1024, or 1024x1792.
type BetaToolLocalShell struct{…}A tool that allows the model to execute shell commands in a local environment.
A tool that allows the model to execute shell commands in a local environment.
type BetaFunctionShellTool struct{…}A tool that allows the model to execute shell commands.
A tool that allows the model to execute shell commands.
Environment BetaFunctionShellToolEnvironmentUnionOptional
type BetaContainerAuto struct{…}
MemoryLimit BetaContainerAutoMemoryLimitOptionalThe memory limit for the container.
The memory limit for the container.
NetworkPolicy BetaContainerAutoNetworkPolicyUnionOptionalNetwork access policy for the container.
Network access policy for the container.
Skills []BetaContainerAutoSkillUnionOptionalAn optional list of skills referenced by id or inline data.
An optional list of skills referenced by id or inline data.
type BetaInlineSkill struct{…}
Source BetaInlineSkillSourceInline skill payload
Inline skill payload
type BetaCustomTool struct{…}A custom tool that processes input using a specified format. Learn more about custom tools
A custom tool that processes input using a specified format. Learn more about custom tools
Format BetaCustomToolFormatUnionOptionalThe input format for the custom tool. Default is unconstrained text.
The input format for the custom tool. Default is unconstrained text.
type BetaNamespaceTool struct{…}Groups function/custom tools under a shared namespace.
Groups function/custom tools under a shared namespace.
Tools []BetaNamespaceToolToolUnionThe function/custom tools available inside this namespace.
The function/custom tools available inside this namespace.
type BetaNamespaceToolToolFunction struct{…}
type BetaCustomTool struct{…}A custom tool that processes input using a specified format. Learn more about custom tools
A custom tool that processes input using a specified format. Learn more about custom tools
Format BetaCustomToolFormatUnionOptionalThe input format for the custom tool. Default is unconstrained text.
The input format for the custom tool. Default is unconstrained text.
type BetaToolSearchTool struct{…}Hosted or BYOT tool search configuration for deferred tools.
Hosted or BYOT tool search configuration for deferred tools.
type BetaWebSearchPreviewTool struct{…}This tool searches the web for relevant results to use in a response. Learn more about the web search tool.
This tool searches the web for relevant results to use in a response. Learn more about the web search tool.
Type BetaWebSearchPreviewToolTypeThe type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11.
The type of the web search tool. One of web_search_preview or web_search_preview_2025_03_11.
SearchContextSize BetaWebSearchPreviewToolSearchContextSizeOptionalHigh level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
UserLocation BetaWebSearchPreviewToolUserLocationOptionalThe user’s location.
The user’s location.
The two-letter ISO country code of the user, e.g. US.
The IANA timezone of the user, e.g. America/Los_Angeles.
type BetaResponseOutputItemAdditionalTools struct{…}
Role stringThe role that provided the additional tools.
The role that provided the additional tools.
Tools []BetaToolUnionThe additional tool definitions made available at this item.
The additional tool definitions made available at this item.
type BetaFunctionTool struct{…}Defines a function in your own code the model can choose to call. Learn more about function calling.
Defines a function in your own code the model can choose to call. Learn more about function calling.
type BetaFileSearchTool struct{…}A tool that searches for relevant content from uploaded files. Learn more about the file search tool.
A tool that searches for relevant content from uploaded files. Learn more about the file search tool.
Filters BetaFileSearchToolFiltersUnionOptionalA filter to apply.
A filter to apply.
type BetaFileSearchToolFiltersComparisonFilter struct{…}A filter used to compare a specified attribute key to a given value using a defined comparison operation.
A filter used to compare a specified attribute key to a given value using a defined comparison operation.
Type stringSpecifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equals
ne: not equal
gt: greater than
gte: greater than or equal
lt: less than
lte: less than or equal
in: in
nin: not in
Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equalsne: not equalgt: greater thangte: greater than or equallt: less thanlte: less than or equalin: innin: not in
type BetaFileSearchToolFiltersCompoundFilter struct{…}Combine multiple filters using and or or.
Combine multiple filters using and or or.
Filters []BetaFileSearchToolFiltersCompoundFilterFilterArray of filters to combine. Items can be ComparisonFilter or CompoundFilter.
Array of filters to combine. Items can be ComparisonFilter or CompoundFilter.
type BetaFileSearchToolFiltersCompoundFilterFilter struct{…}A filter used to compare a specified attribute key to a given value using a defined comparison operation.
A filter used to compare a specified attribute key to a given value using a defined comparison operation.
Type stringSpecifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equals
ne: not equal
gt: greater than
gte: greater than or equal
lt: less than
lte: less than or equal
in: in
nin: not in
Specifies the comparison operator: eq, ne, gt, gte, lt, lte, in, nin.
eq: equalsne: not equalgt: greater thangte: greater than or equallt: less thanlte: less than or equalin: innin: not in
The maximum number of results to return. This number should be between 1 and 50 inclusive.
RankingOptions BetaFileSearchToolRankingOptionsOptionalRanking options for search.
Ranking options for search.
type BetaComputerTool struct{…}A tool that controls a virtual computer. Learn more about the computer tool.
A tool that controls a virtual computer. Learn more about the computer tool.
type BetaComputerUsePreviewTool struct{…}A tool that controls a virtual computer. Learn more about the computer tool.
A tool that controls a virtual computer. Learn more about the computer tool.
type BetaWebSearchTool struct{…}Search the Internet for sources related to the prompt. Learn more about the
web search tool.
Search the Internet for sources related to the prompt. Learn more about the web search tool.
Type BetaWebSearchToolTypeThe type of the web search tool. One of web_search or web_search_2025_08_26.
The type of the web search tool. One of web_search or web_search_2025_08_26.
SearchContextSize BetaWebSearchToolSearchContextSizeOptionalHigh level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
High level guidance for the amount of context window space to use for the search. One of low, medium, or high. medium is the default.
UserLocation BetaWebSearchToolUserLocationOptionalThe approximate location of the user.
The approximate location of the user.
The two-letter ISO country code of the user, e.g. US.
The IANA timezone of the user, e.g. America/Los_Angeles.
type BetaToolMcp struct{…}Give the model access to additional tools via remote Model Context Protocol
(MCP) servers. Learn more about MCP.
Give the model access to additional tools via remote Model Context Protocol (MCP) servers. Learn more about MCP.
AllowedTools BetaToolMcpAllowedToolsUnionOptionalList of allowed tool names or a filter object.
List of allowed tool names or a filter object.
type BetaToolMcpAllowedToolsMcpToolFilter struct{…}A filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
An OAuth access token that can be used with a remote MCP server, either with a custom MCP server URL or a service connector. Your application must handle the OAuth authorization flow and provide the token here.
ConnectorID stringOptionalIdentifier for service connectors, like those available in ChatGPT. One of
server_url, connector_id, or tunnel_id must be provided. Learn more
about service connectors here.
Currently supported connector_id values are:
- Dropbox:
connector_dropbox
- Gmail:
connector_gmail
- Google Calendar:
connector_googlecalendar
- Google Drive:
connector_googledrive
- Microsoft Teams:
connector_microsoftteams
- Outlook Calendar:
connector_outlookcalendar
- Outlook Email:
connector_outlookemail
- SharePoint:
connector_sharepoint
Identifier for service connectors, like those available in ChatGPT. One of
server_url, connector_id, or tunnel_id must be provided. Learn more
about service connectors here.
Currently supported connector_id values are:
- Dropbox:
connector_dropbox - Gmail:
connector_gmail - Google Calendar:
connector_googlecalendar - Google Drive:
connector_googledrive - Microsoft Teams:
connector_microsoftteams - Outlook Calendar:
connector_outlookcalendar - Outlook Email:
connector_outlookemail - SharePoint:
connector_sharepoint
Optional HTTP headers to send to the MCP server. Use for authentication or other purposes.
RequireApproval BetaToolMcpRequireApprovalUnionOptionalSpecify which of the MCP server’s tools require approval.
Specify which of the MCP server’s tools require approval.
type BetaToolMcpRequireApprovalMcpToolApprovalFilter struct{…}Specify which of the MCP server’s tools require approval. Can be
always, never, or a filter object associated with tools
that require approval.
Specify which of the MCP server’s tools require approval. Can be
always, never, or a filter object associated with tools
that require approval.
Always BetaToolMcpRequireApprovalMcpToolApprovalFilterAlwaysOptionalA filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
Never BetaToolMcpRequireApprovalMcpToolApprovalFilterNeverOptionalA filter object to specify which tools are allowed.
A filter object to specify which tools are allowed.
Indicates whether or not a tool modifies data or is read-only. If an
MCP server is annotated with readOnlyHint,
it will match this filter.
Optional description of the MCP server, used to provide more context.
type BetaToolCodeInterpreter struct{…}A tool that runs Python code to help generate a response to a prompt.
A tool that runs Python code to help generate a response to a prompt.
Container BetaToolCodeInterpreterContainerUnionThe code interpreter container. Can be a container ID or an object that
specifies uploaded file IDs to make available to your code, along with an
optional memory_limit setting.
The code interpreter container. Can be a container ID or an object that
specifies uploaded file IDs to make available to your code, along with an
optional memory_limit setting.
type BetaToolCodeInterpreterContainerCodeInterpreterToolAuto struct{…}Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
Configuration for a code interpreter container. Optionally specify the IDs of the files to run the code on.
MemoryLimit stringOptionalThe memory limit for the code interpreter container.
The memory limit for the code interpreter container.
NetworkPolicy BetaToolCodeInterpreterContainerCodeInterpreterToolAutoNetworkPolicyUnionOptionalNetwork access policy for the container.
Network access policy for the container.
type BetaToolImageGeneration struct{…}A tool that generates images using the GPT image models.
A tool that generates images using the GPT image models.
Background stringOptionalAllows to set transparency for the background of the generated image(s).
This parameter is only supported for GPT image models that support
transparent backgrounds. Must be one of transparent, opaque, or
auto (default value). When auto is used, the model will
automatically determine the best background for the image.
gpt-image-2 and gpt-image-2-2026-04-21 do not support
transparent backgrounds. Requests with background set to
transparent will return an error for these models; use opaque or
auto instead.
If transparent, the output format needs to support transparency,
so it should be set to either png (default value) or webp.
Allows to set transparency for the background of the generated image(s).
This parameter is only supported for GPT image models that support
transparent backgrounds. Must be one of transparent, opaque, or
auto (default value). When auto is used, the model will
automatically determine the best background for the image.
gpt-image-2 and gpt-image-2-2026-04-21 do not support
transparent backgrounds. Requests with background set to
transparent will return an error for these models; use opaque or
auto instead.
If transparent, the output format needs to support transparency,
so it should be set to either png (default value) or webp.
InputFidelity stringOptionalControl how much effort the model will exert to match the style and features, especially facial features, of input images. This parameter is only supported for gpt-image-1 and gpt-image-1.5 and later models, unsupported for gpt-image-1-mini. Supports high and low. Defaults to low.
[...]
